 
  'Bosch KF161 ombouw voor 40 kanalen eprom berekening 20 jan 1999 PA0PDO
 
  DIM D$(80, 1): DEFINT I-K, T: lijst$ = "freq.lst"
   ON ERROR GOTO foutopvang
   OPEN "KF161.INI" FOR INPUT AS #1: INPUT #1, lijst$: CLOSE #1

   COLOR 15, 1: CLS : PRINT : COLOR 0, 7: LOCATE 2, 11
   PRINT ; "  Bosch KF161 40 kanalen 27128 eprom programma (PA0PDO)  "
   COLOR 15, 1: PRINT
   PRINT TAB(30); " BELANGRIJK !"
   PRINT TAB(11); "Zorg voor een lijst op papier van de door U gewenste freq."
   PRINT TAB(11); "Bewerk de lijst met de editor (muis ondersteund)"
   PRINT TAB(11); "Sla op met ALT  F  X": PRINT
   PRINT TAB(11); "Frequentie lijst bestandnaam: "; lijst$
herhaal:
   LOCATE 9, 41: INPUT "", A$: IF A$ <> "" THEN lijst$ = A$
   IF LEN(lijst$) > 12 THEN
     PRINT TAB(11); "Ongeldige naam!"; TAB(41); "PA0XYZ.LST"
     GOTO herhaal
   END IF
   LOCATE 9, 41 + LEN(lijst$): PRINT STRING$(39 - LEN(lijst$), 32)
   LOCATE 10, 11: PRINT STRING$(40, 32)
   oproep$ = "EDIT " + lijst$
   SHELL oproep$

'------------ 80 hex adressen berekenen,in D$(80,0) opslaan ---------------
  tel = 0
  FOR J = 0 TO 7
    FOR I = 0 TO 9
      adres = 16383 - (J * 1024) - (2 ^ I) '16383 = max adres 27128
      tel = tel + 1
      D$(tel, 0) = HEX$(adres + 256)       '256 = offset voor debug 100hex
   NEXT I, J
'-------- freq controleren op geldigheid en bytes berekenen ----------------
test:
  OPEN lijst$ FOR INPUT AS #2
  LINE INPUT #2, dummy$: LINE INPUT #2, dummy$     'bovenste 2 lijnen lezen
  DEFDBL A: kan = 0: tel = 0

 FOR K = 1 TO 4
   FOR J = 0 TO 1
     LINE INPUT #2, dummy$                 'tabelkop lezen
       FOR I = 1 TO 10
         kan = kan + 1: tel = tel + 1
         LINE INPUT #2, freq$
         C = VAL(LEFT$(freq$, 8))
         LOCATE 11, 11
       
         IF C < 144437.5 THEN
           IF J THEN
           PRINT "Zend kanaal"; kan - 10;
           ELSE PRINT "Ontv kanaal"; kan;
           END IF
           PRINT "   freq"; C; "= te laag!  minimaal 144437.5"
           PRINT TAB(11); "<enter>"
           DO: P$ = INKEY$: LOOP UNTIL P$ = CHR$(13)
           CLOSE #2: SHELL oproep$: GOTO test
         END IF
       
         IF C >= 146000 THEN
           IF J THEN
           PRINT "Zend kanaal"; kan - 10;
           ELSE PRINT "Ontv kanaal"; kan;
           END IF
           PRINT "   freq"; C; "= te hoog!  maximaal 145987.5"
           PRINT TAB(11); "<enter>"
           DO: P$ = INKEY$: LOOP UNTIL P$ = CHR$(13)
           CLOSE #2: SHELL oproep$: GOTO test
         END IF
          
         IF (C / 12.5) <> INT(C / 12.5) THEN
           IF J THEN
           PRINT "Zend kanaal"; kan - 10;
           ELSE PRINT "Ontv kanaal"; kan;
           END IF
           PRINT "   freq"; C; "= geen 12.5kHz rasterfreq.    "
           PRINT TAB(11); "<enter>"
           DO: P$ = INKEY$: LOOP UNTIL P$ = CHR$(13)
           CLOSE #2: SHELL oproep$: GOTO test
         END IF
        
         C$ = STR$((C - 10700) / 12.5)                'byte berekenen
         B = VAL(MID$(C$, 2, 3)): A = VAL(RIGHT$(C$, 2))
         A = (NOT A) AND 255
         IF B = 108 THEN
              D$(tel, 1) = HEX$(A AND 127) 'byte --> D$(80,1)
         ELSE D$(tel, 1) = HEX$(A OR 128)
         END IF
    
     NEXT I, J
     kan = kan - 10
   NEXT K
  CLOSE #2

 
  PRINT "Goed nieuws.... Uw frequenties gecontroleerd en ok!        "
  PRINT TAB(11); "<enter>"
  DO: P$ = INKEY$: LOOP UNTIL P$ = CHR$(13)
'-------------- Samen voegen van eprom adressen en bytes -------------------

  ident$ = "KF161 " + lijst$
  FOR I = 1 TO LEN(ident$)
   text$ = text$ + " " + HEX$(ASC(MID$(ident$, I, 1)))
  NEXT:
  text$ = "e 100" + text$

  OPEN "128debug.lst" FOR OUTPUT AS #3
  PRINT #3, "f 0100 4100 FF"    'fill  0000--> 4000 met FF
  PRINT #3, text$               'KF161 PA0XYZ.LST   identificatie text
 
  FOR I = 1 TO 80
    PRINT #3, "e   "; D$(I, 0); "   "; D$(I, 1)
  NEXT I
  REM het formaat voor debug is--> e   FFFE   A7
  PRINT #3, "r cx"                'register cx
  PRINT #3, "4000"                'load 4000h
  PRINT #3, "n fik128.bin"        'output file name
  PRINT #3, "w 0100"              'write offset
  PRINT #3, "q"                   'quit debug
  CLOSE #3                        'sluit fik128.bin

'------------ 128debug.lst omzetten in fik128.bin -----------------------

  SHELL "debug < 128debug.lst"
  CLS : LOCATE 5.1
  PRINT "    Klaar,nu nog fik128.bin in een 27128 eprom (laten) branden."
  PRINT : PRINT
  PRINT "                                                              1Ŀ28"
  PRINT "    Buig A11 en A12 (pootjes 23,2) buiten voetje,soldeer      2       "
  PRINT "    van hier 100k weerstandjes naar de + 5V aansluiting               "
  PRINT "    Trek 2 draadjes vanaf midden kontakt van de                   2   23"
  PRINT "    schakelaars I en II naar pootjes 23 en 2.                     7   "
  PRINT "                                                                  1   "
  PRINT "    Heeft U voldoende aan 20 kanalen laat dan het draadje         2    "
  PRINT "    tussen schakelaar II en pootje 2 achterwege.                  8   "
  PRINT "                                                                      "
  PRINT "                                                             1415"
  PRINT : PRINT : PRINT
  PRINT "    Veel plezier met uw 40 kanaals KF161!"
  PRINT "    PA0PDO @PI8SHB"
  PRINT "    <enter>"
 
  DO: P$ = INKEY$: LOOP UNTIL P$ = CHR$(13)
  OPEN "KF161.INI" FOR OUTPUT AS #4: PRINT #4, lijst$: CLOSE #4
  SHELL "DEL 128DEBUG.LST"
  SYSTEM

foutopvang:
  IF ERR = 53 THEN CLOSE #1
  RESUME NEXT

